// *************************************************************************************************************
// * OTG HIDꊇ(AT90USB647/1287)pgp۸ ̧قłB
// * OTĢѳ@\ɉAȉ܂݂܂B
// *  - t̓ORG@\v:
// *    + νē:
// *      - HWB : (A-ủꂩ̏Ԃ)VBUSݐ؂ւ
// *      - ޮè̑I/ : (A-νĂ܂B-νĂ)HNPv
// *    + Ӌ@\:
// *      - HWB : (B-IDLE)SRPo
// *      - ޮè̑I/ : (A-Ӌ@\܂B-Ӌ@\)νHID LEDݐ؂ւ
// *
// *  - {IHIDϳp: 
// *     -> u`ԂŁAu͒tł̸د񍐂𑗏o܂B
// *     -> νē`ԂŁAϳ܂HID݊uڑ邱Ƃł܂B̧ѳ͊eدLED̏Ԃݐ؂ւ܂B
// *
// *  - үދ@\pLED : STK5254̒PFLEDAUSBKEY22FLED
// *     LED蓖ĂɂĂ"otg_user_task"QƂĂB
// *     -> Led_noresponse() : "uȂ"}
// *     -> Led_usb_connected() : wALED͗(ڑF)ƁAӋ@\`ԂONłB
// *     -> Led_hid() : νđŁALED͎Ӌ@\د񍐂𑗂閈Ɍݐ؂ւ܂B
// *     -> Led_unsupported() : "xu"}
// *************************************************************************************************************

// MCU͊O8MHzgpłB
// gp҂(I2ms荞݂𐶐邽߂)ۯOu`Ԑݒ\ݒwȂ΂Ȃ܂B
#define OSC_CORE_PRESCALER			NO_PRESC

//___________ ݸٰ _________________________________
#include "config.h"
#include "conf_usb.h"
#include "lib_mcu/usb/usb_drv.h"
#include "modules/usb/usb_task.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "modules/usb/host_chap9/usb_host_task.h"
#include "modules/usb/device_chap9/usb_device_task.h"
#include "modules/usb/host_chap9/usb_host_enum.h"
#include "lib_mcu/timer/timer16_drv.h"
#include "lib_mcu/usb/usb_drv.h"
#include "otg_user_task.h"
//#include "lib_mcu/adc/adc_drv.h"
#include "lib_mcu/pll/pll_drv.h" 

//___________ ϐ _____________________________________
U8 PIPE_SPIDER_IN;

volatile U8 button_high;

volatile U8 device_connected;
volatile U8 previous_session, previous_vbus;

volatile S8 mouse_move;
volatile S8 Usb_report[4];
volatile U8 Usb_report_status;

#if (USE_TIMER16 == BOTH_TIMER16)
  U8 timer16_selected;
#endif

// ***************************************
// **
// **  ۸
// **
// ***************************************

void otg_user_task_init (void)
{
	// 
	Leds_init();
	Joy_init();
	Hwb_button_init();
	Leds_off();

	previous_session = SESSION_DEVICE;		// Led_print_otg_status()֐ɍŏ̏Ԃ\邽
	previous_vbus = 0;
	device_connected = SESSION_OFF;
	Led_print_otg_status();

	Enable_interrupt();

	Clear_usb_report();
	Usb_report_status = USB_READ_PACKET;
	button_high = FALSE;
}

void otg_user_task (void)
{
	U8 i;

	// =================
	// ** USBʊǗ **
	// =================

	// ======================
	// νēłUSBʊǗ
	// ======================
	if (Is_usb_host_enabled())
	{
		if (Is_host_ready())
		{
			// νēŁAVӋ@\ڑꂽ𒲍
			if (Is_new_device_connection_event())
			{
				for(i=0;i<Get_nb_supported_interface();i++)
				{
					if (Get_class(i)==HID_CLASS && Get_protocol(i)==MOUSE_PROTOCOL)
					{
						device_connected = SESSION_HOST;
						Led_usb_connected_off();
						Led_hid_off();
						host_hid_set_idle();
						host_get_hid_repport_descriptor();
						PIPE_SPIDER_IN = host_get_hwd_pipe_nb(Get_ep_addr(i,0));
						Host_select_pipe(PIPE_SPIDER_IN);
						Host_continuous_in_mode();
						Host_unfreeze_pipe();
						button_high = FALSE;
						mouse_move = 0;
						break;
					}
				}
			}
		}
		else
		{
			Led_usb_connected_off();
			Led_hid_off();
			device_connected = SESSION_OFF;
		}

		// ؒf
		if(Is_device_disconnection_event())
		{
			Led_usb_connected_off();
			Led_hid_off();
			device_connected = SESSION_OFF;
		}

		// νēŁAVM߹ĂɊւĒ
		if (device_connected == SESSION_HOST)	// Ӌ@\ڑė(ڑF)ꂽB
		{
			// 1. uVް𓾂B
			Host_select_pipe(PIPE_SPIDER_IN);
			if ((Is_host_in_received()) && (Is_host_stall()==FALSE) && (Usb_report_status != USB_NEW_PACKET))
			{
				i = 0;
				while ((UPBCLX != 0) && (i != 4))
				{
					Usb_report[i] = Host_read_byte();
					i++;
				}
				Usb_report_status = USB_NEW_PACKET;

				Host_ack_in_received();
				Host_send_in();
			}
		}
	}

	// =======================
	// ułUSBʊǗ
	// =======================
	if (Is_usb_device_enabled())
	{
		if (usb_configuration_nb != 0)		// u`Ԑݒ肳ė(ڑF)ꂽ?
		{
			Led_usb_connected_on();
			device_connected = SESSION_DEVICE;
			Usb_select_endpoint(EP_SPIDER_IN);	// νĂް𑗂߲
			if ((Is_usb_write_enabled()) && (Usb_report_status == USB_NEW_PACKET))
			{
				Usb_write_byte(Usb_report[0]);
				Usb_write_byte(Usb_report[1]);
				Usb_write_byte(Usb_report[2]);
				Usb_write_byte(Usb_report[3]);
				Usb_report_status = USB_READ_PACKET;
				Usb_ack_fifocon();			// USBްo
				Clear_usb_report();
			}
		}
		else
		{
				Led_usb_connected_off();
				Led_hid_off();
				device_connected = SESSION_OFF;
		}
	}

	// =============================================================
	// ****** p ******
	// u : tɂĂ̏(/J)HID񍐂𑗏o
	// νē : tʒuɑΉLEDݐ؂ւ
	// =============================================================
	if (device_connected == SESSION_DEVICE)
	{
		// ϳړ擾
		// r(4%葽)ω̏ꍇAႢνĂɑ܂B
		if (Usb_report_status != USB_NEW_PACKET)
		{
			if (Is_joy_select())
			{
				// tUSB߲ ߰ݸގg("usb_descriptors.h"EP_INTERVAL_1l)ɂď܂B
				Usb_report[0] = 0x01;
				Usb_report_status = USB_NEW_PACKET;
			}
			else
			{
				Usb_report[0] = 0x00;
				Usb_report_status = USB_NEW_PACKET;
			}
		}
	}

	if (device_connected == SESSION_HOST)
	{
		if (Usb_report_status == USB_NEW_PACKET)
		{
			if ((Usb_report[0]&0x01) == 0)
			{
				if (button_high == TRUE)    { button_high = FALSE; }
			}
			else
			{
				if (button_high == FALSE)
				{
					button_high = TRUE;
					Led_hid_toggle();
			}
		}
			Usb_report_status = USB_READ_PACKET;
			Clear_usb_report();
		}
	}

	// ==========================================
	// OTGgpҗvǗ
	// ɏ]At͈قȂ鎖ۂn߂܂B
	// ==========================================
	if (Is_usb_device_enabled())
	{
		if (!Is_usb_id_host() && (usb_configuration_nb == 0))
		{
			// SRPv:HWBt
			// ***********
			if (Is_hwb())
			{
				Bp_delay_debounce();
				while (Is_hwb());
				Bp_delay_debounce();
				Set_user_request_srp();
			}
		}
		if (Is_usb_id_host())
		{
			// VBUSݐ؂ւv:HWBt	// A-Ӌ@\쎞ɍƏI
			// *******************
			if (Is_hwb())
			{
				Bp_delay_debounce();
				while (Is_hwb());
				Bp_delay_debounce();
				Set_user_request_vbus();
			}
		}
	}

	if (Is_usb_host_enabled())
	{
		// VBUSݐ؂ւv:HWBt
		// *******************
		if (Is_hwb())
		{
			Bp_delay_debounce();
			while (Is_hwb());
			Bp_delay_debounce();
			Set_user_request_vbus();
		}

		// HNPݐ؂ւv:t
		// *******************
		if (Is_joy_select())
		{
			Bp_delay_debounce();
			while (Is_joy_select());
			Bp_delay_debounce();
			Set_user_request_hnp();
		}
	}

	Led_print_otg_status();
}

// ̊֐͌Ă΂ꂽOTG܂B
// VBUSԂƌ݂̍(HOST,DEVICE,OFF;̏Ԃǉ邱Ƃł܂B-4)\܂B
void Led_print_otg_status (void)
{
	U8 vbus_state = 0;
	if ((Is_usb_vbus_high()) || ((Is_usb_id_host()) && ((PORTE&0x80) != 0))) { vbus_state = 1; }
	if ((previous_session != device_connected) || (previous_vbus != vbus_state))
	{
		switch (device_connected)
		{
			case SESSION_HOST:
				Led_usb_connected_off();
				break;

			case SESSION_DEVICE:
				Led_usb_connected_on();
				break;

			case SESSION_OFF:
				Led_usb_connected_off();
				break;

			default:
				Led_usb_connected_off();
				break;
		}
		previous_session = device_connected;
		previous_vbus = vbus_state;
	}
}

//-----------------------------------------------------------------
// үދ@\
// **********

void Otg_messaging_init (void)
{
	Led_unsupported_off();
	Led_noresponse_off();
}

// ͂Ƃĕԍ𓾂LCDɑΉ鎸s֐
void Otg_output_failure_msg (U8 str_nb)
{
	switch (str_nb)
	{
		case OTGMSG_UNSUPPORTED:
			// үނɑ΂鏈ނɒuĂB
			Led_unsupported_on();
			break;

		case OTGMSG_UNSUPPORTED_HUB:
			// үނɑ΂鏈ނɒuĂB
			Led_unsupported_on();
			break;

		case OTGMSG_DEVICE_NO_RESP:
			// үނɑ΂鏈ނɒuĂB
			Led_noresponse_on();
			break;

		case OTGMSG_SRP_A_NO_RESP:
			// үނɑ΂鏈ނɒuĂB
			Led_noresponse_on();
			break;

		default:
			break;
	}
}

// sҰނ̍s
void Otg_clear_failure_message()
{
	Led_unsupported_off();
	Led_noresponse_off();
}
