 //!
//! @file usb_task.c,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͑u/νĂ܂͗̂ǂꂩUSBƂǗ܂B
//!
//! USBƂ͐USB(ݗp\ȓ`ԂɈˑĎsׂ
//! usb_deviceƂ܂usb_host)Iт܂B
//!
//! (conf_usb.ḩٓɔzuꂽ)USB_DEVICE_FEATUREUSB_HOST_FEATURElɏ]
//! ܂Busb_taskUSBu`Ԃ܂USBνē`ԁA܂͓dup
//! ɊւĂ̗x悤Ɍ`Ԑݒ肷邱Ƃł܂B
//!
//! ̕USBSʊ荞ݻٰ݂܂݂܂Bٰ̻݂͔񓯊USBۂ̌
//! oɎgp܂B
//!
//! :
//! - usb_task͌v敔ɑAusb_device_taskusb_host͂łȂA͑S
//!	  ʓIusb_taskĂяo܂B
//! - ̌̕`ԐݒɂĂ̂葽̏ڍׂɊւĂconf_usb.ḩق
//!	  B
//!
//! @version 1.30 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_task.c,v 1.30 2007/02/19 08:21:27 arobert Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"

#if (USB_OTG_FEATURE == ENABLED)
  #include "lib_mcu/timer/timer16_drv.h"
  #if (TARGET_BOARD==SPIDER)
	#include "lib_board/lcd/lcd_drv.h"
  #endif
#endif

#include "usb_task.h"
#include "lib_mcu/usb/usb_drv.h"
#if ((USB_DEVICE_FEATURE == ENABLED))
#include "usb_descriptors.h"
#endif
#include "lib_mcu/power/power_drv.h"
#include "lib_mcu/wdt/wdt_drv.h"
#include "lib_mcu/pll/pll_drv.h"

#if ((USB_HOST_FEATURE == ENABLED))
  #include "modules/usb/host_chap9/usb_host_task.h"
  #if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
	extern U8 g_sav_int_sof_enable;
  #endif
#endif

#if ((USB_DEVICE_FEATURE == ENABLED))
  #include "modules/usb/device_chap9/usb_device_task.h"
#endif

#ifndef  USE_USB_PADS_REGULATOR
  #error "USE_USB_PADS_REGULATOR" should be defined as ENABLE or DISABLE in conf_usb.h file
#endif

//_____ ϸ ___________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_device_disconnect[]="Device Disconnected";
U8 code log_id_change[]="Pin Id Change";
#endif

//_____ ` __________________________________________________________________

//!
//! J : U16 g_usb_event
//! usb_connectedUSBSʊ荞ݻٰ݂ŌoꂽUSBۂi[̂Ɏgp
//! ܂B
//! ̒l͈ȉϸۂɂĊǗ܂(usb_task.ḩق)B
//! Usb_send_event(x)
//! Usb_ack_event(x)
//! Usb_clear_all_event()
//! Is_usb_event(x)
//! Is_not_usb_event(x)
volatile U16 g_usb_event=0;

#if (USB_DEVICE_FEATURE == ENABLED)
//!
//! J : (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected̑̏ꍇFALSEɐݒ肳܂B
//! USB_DEVICE_FEATURE==ENABLEDłgp܂B
//!/
extern bit usb_connected;

//!
//! J : (U8) usb_configuration_nb
//! ̒l0ƈقȂ鎞USBuɂĎgpUSB`Ԑݒ萔i[A
//! u`Ԃ(ڑF)ꂽƂӖ܂B
//! USB_DEVICE_FEATURE==ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;

//!
//! J: (U8) remote_wakeup_feature
//! uNɑ΂νėvi[܂(@\M)B
//!/
U8 remote_wakeup_feature;
#endif

#if (USB_HOST_FEATURE == ENABLED)
//!
//! I: (U8) private_sof_counter
//! νSOF荞ݻٰ݂ɂđ܂B
//! ̌vνėvł̎ԒߌoɎgp܂B
//! ͎gp҉pƂɂĕύXĂ͂Ȃ܂B
//!/
volatile U8 private_sof_counter=0;

  #if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
extern volatile S_pipe_int it_pipe_str[MAX_EP_NB];
  #endif

#endif

#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
//!
//! J: (U8) g_usb_mode
//! USB킪삷錻݂̓`Ԃi[邽߂2d(u/νĂ̗)
//! pŎgp܂B
//!/
U8 g_usb_mode=USB_MODE_UNDEFINED;
U8 g_old_usb_mode;
#endif


#if (USB_OTG_FEATURE == ENABLED)
  //!
  //! J: (U8) otg_features_supported
  //!  A-u: B-uHNPSRPx邩(OTGLqqbmAttributes̈ł)B
  //!  B-u: A-u"a_hnp_support""b_hnp_enable"̋@\Ă邩B
  volatile U8 otg_features_supported;

  //! J: (U8) otg_user_request
  //! gp҂̍Ō̗vi[(usb_device_task.hB)
  U8 otg_user_request;

  //! J: (U16) otg_msg_event_delay
  //! OTGүނ݂̌̕\Ԃ܂݂܂B
  U16 otg_msg_event_delay;

  //! J: (U16) otg_msg_failure_delay
  //! OTGsүނ݂̌̕\Ԃ܂݂܂B
  U16 otg_msg_failure_delay;

  //! J: (U16) g_otg_event
  //! eOTG(g_usb_eventl)ɑΉlXޯĂ܂݂܂B
  volatile U16 g_otg_event;

  //! J: (U8) otg_device_nb_hnp_retry
  //! 쒆~OHNPs̉񐔂v
  U8 otg_device_nb_hnp_retry;

  #if (OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED)
	U8 id_changed_to_host_event;
  #endif

  #if (OTG_COMPLIANCE_TRICKS == ENABLED)
	volatile U8 otg_last_sof_received;		// SOF荞݂ŎMŌSOF
	volatile U8 otg_last_sof_stored;		// OTGv튄荞݂Ŋi[ŌSOFl
	volatile U8 reset_received;				// (A-Ӌ@\Ŏgpꂽ)HNPؾĂB-νĂ󂯎ꂽB
  #endif

  //! @brief VBUSߕ׊Ǘ
  //!
  //! 邱Ɩ!Bײ ̧قŒ`ĂȂ(ƁA
  //! VBUSߓdoxȂ)ꍇAϸۂ̧ѳKɑ΂FALSEɒ`
  //! ܂B
  #ifndef Is_vbus_overcurrent()
	#warning Is_vbus_overcurrent() must be defined if present on board
	#define  Is_vbus_overcurrent() (FALSE)
  #endif

  //! I֐^
  //! OTGүދ@\p
  void Otg_message_task_init (void);
  void Otg_message_task (void);
#endif

//_____ 錾 __________________________________________________________________

/**
 * @brief ̊֐USB܂B
 *
 * x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSB`
 * ֐Ăяo܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 */
void usb_task_init (void)
{
  #if (USB_HOST_FEATURE == ENABLED && USB_DEVICE_FEATURE == ENABLED)
	U8 delay;
  #endif

  #if (USE_USB_PADS_REGULATOR==ENABLE)		// ȂUSB߯ޒ͖gpƉ
	Usb_enable_regulator();
  #endif

// ---- d uUSB` ----------------------------------------------
#if (USB_OTG_FEATURE == ENABLED)
	Otg_message_task_init();				// OTG۸т͎gp҂Ɏүނ\邱ƂKvłB
	Otg_timer_init();						// OTG۸т͗lXOTGLݸނ邽߂TIMER1܂3KvłB
	otg_b_device_state = B_IDLE;			// ԋ@\ϐ
	device_state = DEVICE_UNATTACHED;
	otg_device_nb_hnp_retry = BDEV_HNP_NB_RETRY;
	Clear_all_user_request();
#endif

#if (((USB_DEVICE_FEATURE == ENABLED) && (USB_HOST_FEATURE == ENABLED)) || (USB_OTG_FEATURE == ENABLED))
	Usb_enable_uid_pin();
	delay=PORTA;
	g_usb_mode=USB_MODE_UNDEFINED;
	if(Is_usb_id_device())
	{
		g_usb_mode=USB_MODE_DEVICE;
		usb_device_task_init();
	#if ((OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED) && (USB_OTG_FEATURE == ENABLED))
		id_changed_to_host_event = DISABLED;
	#endif
	}
	else
	{
		Usb_send_event(EVT_USB_HOST_FUNCTION);
		g_usb_mode=USB_MODE_HOST;
		Usb_ack_id_transition();			// Kv!!! ID=0,IDݑJډŎn(ʰ޳n͑u`)
		Usb_enable_id_interrupt();
		Enable_interrupt();
		usb_host_task_init();
	#if ((OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED) && (USB_OTG_FEATURE == ENABLED))
		id_changed_to_host_event = ENABLED;
	#endif
	}
	g_old_usb_mode = g_usb_mode;			// `ԕύXô߂Ɍ݂USB`Ԋi[
// -----------------------------------------------------------------------------

// ---- upUSB` ----------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	Usb_force_device_mode();
	usb_device_task_init();
// -----------------------------------------------------------------------------

// ---- kνĐpUSB` -------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	Usb_force_host_mode();
	usb_host_task_init();
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error at least one of USB_DEVICE_FEATURE or USB_HOST_FEATURE should be enabled
#endif
// -----------------------------------------------------------------------------
}

/**
 * @brief USBǗ̓(_)
 *
 * x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSBǗ֐
 * Ăяo܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
*/
void usb_task (void)
{
// ---- OTGu ---------------------------------------------------------------
//#if (USB_OTG_FEATURE == ENABLED)

// ---- d uUSB` ----------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED) && (USB_HOST_FEATURE == ENABLED))
	if(Is_usb_id_device())
	{ g_usb_mode=USB_MODE_DEVICE;}
	else
	{ g_usb_mode=USB_MODE_HOST;}
	// ׂ!!! ID νďԕύX
	// bǗ:ʰ޳ ؾ!!!
	#if (ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
	// νIDJڂޯ ؾĂ𐶐
	if((g_old_usb_mode!=g_usb_mode))
		#ifndef AVRGCC
		{Wdt_change_16ms(); while(1);   LOG_STR_CODE(log_id_change);}
		#else
		{Wdt_change_enable(); while(1); LOG_STR_CODE(log_id_change);}
		#endif
	#endif
	g_old_usb_mode=g_usb_mode;				// `ԕύXoɑ΂Č݂USB`Ԃi[
	// ݂USB`ԂɈˑAUSB(u܂ν)Jn

	#if (USB_OTG_FEATURE == ENABLED)
	// OTGv`Ԑݒ
	Set_otg_custom_timer(VBUSRISE_70MS);
	Set_otg_custom_timer(VBUSPULSE_40MS);
	Set_otg_custom_timer(VFALLTMOUT_131MS);
	Set_otg_custom_timer(SRPMINDET_100US);
	#endif

	switch(g_usb_mode)
	{
		case USB_MODE_DEVICE:
			usb_device_task();
			break;

		case USB_MODE_HOST:
	#if (OTG_ADEV_SRP_REACTION == VBUS_PULSE)
			Usb_select_vbus_srp_method();
	#else
			Usb_select_data_srp_method();
	#endif
			usb_host_task();
			// VBUSߓdُ폈(x܂͊ײ ̧قŖ`̏ꍇɎ֎~)
	#if (USB_OTG_FEATURE == ENABLED)
			if (Is_vbus_overcurrent())
			{
				Otg_print_new_event_message(OTGMSG_VBUS_SURCHARGE,OTG_TEMPO_3SEC);
			}
	#endif
			break;

		case USB_MODE_UNDEFINED:	// (breakȂ!)
		default:
			break;
	}
// -----------------------------------------------------------------------------

// ---- upUSB` ----------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	usb_device_task();
// -----------------------------------------------------------------------------

// ---- kνĐpUSB` -------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	usb_host_task();
// -----------------------------------------------------------------------------

//! ---- ُAꂽ`ԂȂ ------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error ŒUSB_DEVICE_FEATURE܂USB_HOST_FEATURE1ׂłB
  #error ȂUSBƂׂ͂̂܂B
#endif
// -----------------------------------------------------------------------------

#if (USB_OTG_FEATURE == ENABLED)
	Otg_message_task();
#endif
}

//! @brief USB荞ݻٰ
//!
//! ̊֐USB荞݂NxɌĂ΂܂B
//! ȉUSBۂS܂B
//! - VBUS ON/OFF
//! - ڰт̊Jn
//! - x~(Suspend)
//! - N(Wake-Up)
//! - ĊJ(Resume)
//! - ؾ
//!
//! ȉUSBνĎۂS܂B
//! - uڑ
//! - uؒf
//! - ڰт̊Jn
//! - IDݕω
//! - SOF(܂͒ᑬ(Low-speed)̂܂܈ێ)o
//! - USBoŋN
//!
//! eۂɊւAgp҂͘Ag`邱ƂɂĊJn邱
//! ł܂(ۂŊǉɂconf_usb.ḩق)B
//!
//! : ꂽ荞ݎۂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef AVRGCC
ISR(USB_GEN_vect)
#else
#pragma vector = USB_GENERAL_vect
__interrupt void usb_general_interrupt()
#endif
{
#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
	U8 i;
	U8 save_pipe_nb;
#endif

// ---------- uۊǗ -----------------------------------------------
// -----------------------------------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED) || (USB_OTG_FEATURE == ENABLED))
	//- VBUS󋵌o
	if (Is_usb_vbus_transition() && Is_usb_vbus_interrupt_enabled() && Is_usb_id_device())
	{
		Usb_ack_vbus_transition();
		if (Is_usb_vbus_high())
		{
			usb_connected = TRUE;
			Usb_vbus_on_action();
			Usb_send_event(EVT_USB_POWERED);
			Usb_enable_reset_interrupt();
			usb_start_device();
			Usb_attach();
		}
		else
		{
			Usb_detach();
	#if  (USB_OTG_FEATURE == ENABLED)
			Usb_device_stop_hnp();
			Usb_select_device();
			Clear_all_user_request();
	#endif
			Usb_vbus_off_action();
			usb_connected = FALSE;
			usb_configuration_nb = 0;
			Usb_send_event(EVT_USB_UNPOWERED);
		}
	}
	// - uڰъJnM
	if (Is_usb_sof() && Is_sof_interrupt_enabled())
	{
		Usb_ack_sof();
		Usb_sof_action();
	#if (USB_OTG_FEATURE == ENABLED)
		sof_seen_in_session = TRUE;
		#if (OTG_COMPLIANCE_TRICKS == ENABLED)
		otg_last_sof_received = UDFNUML;	// MŌڰєԍi[
		#endif
	#endif
	}
	// - ux~(XȂUSB̓oȂ)
	if (Is_usb_suspend() && Is_suspend_interrupt_enabled())
	{
	#if (USB_OTG_FEATURE == ENABLED)
		// ŏ:B-Ӌ@\?
		if (Is_usb_id_device())
		{
			// HNP
			if (Is_host_requested_hnp()		// "b_hnp_enable"@\M
			&& (Is_session_started_with_srp() || Is_user_requested_hnp() || (OTG_B_DEVICE_AUTORUN_HNP_IF_REQUIRED == ENABLED)))
			{
				if (otg_device_nb_hnp_retry == 0)
				{
					otg_features_supported &= ~OTG_B_HNP_ENABLE;
				}
				else
				{
					Ack_user_request_hnp();
					Usb_ack_hnp_error_interrupt();
					Usb_ack_role_exchange_interrupt();
					Usb_enable_role_exchange_interrupt();
					Usb_enable_hnp_error_interrupt();
					Usb_device_initiate_hnp();
					otg_device_nb_hnp_retry--;
				}
				Usb_ack_suspend();
			}
			else
			{
				// uNオ菈
				if ((remote_wakeup_feature == ENABLED) && (usb_configuration_nb != 0))
				{

					Usb_disable_suspend_interrupt();
					Usb_ack_wake_up();
					Usb_enable_wake_up_interrupt();
					// ̌ɉuNオn߂邽߂Ɏgp҂"Usb_initiate_remote_wake_up()"s邱Ƃł܂B
					// ĊJ(Resume)邽߂ɋx~(Suspend)荞(SUSPI)׸ނݒ肳ĂȂ΂ȂȂƂɒӂĂB
					// ̂ɏ璷Ȋ荞݂邽߂SUSPEޯĂ͉Ȃ΂Ȃ܂B
					// ****************
					// ĊJ(νĐؒf)VBUSA(uNオJnɎgpĂꂪʏ푗ꂽʰ޳ɂĉ)
					// RMWKUPޯĂیɐݒɗ܂Âɂ̋@\ǂ@ȉł邱ƂɂӂĂB
//					Usb_initiate_remote_wake_up();
//					while (Is_usb_pending_remote_wake_up())
//					{
//						if (Is_usb_vbus_low())
//						{
//							// ĊJVBUSȂAً}(ؾ ϸۂȂ)
//							break;
//						}
//					}
//					Usb_ack_remote_wake_up_start();
					// ****************
				}
				else
				{
					// uNオxȂ
					Usb_send_event(EVT_USB_SUSPEND);
					Usb_suspend_action();
					Usb_ack_suspend();
					Usb_ack_wake_up();					// ̎یô߂ɋNオ
					Usb_enable_wake_up_interrupt();
					Usb_freeze_clock();
				}
			}
		}
		else
		{
			// A-Ӌ@\(usb_host_task.cňƏIN܂B)
			Usb_send_event(EVT_USB_SUSPEND);
			Usb_suspend_action();
			Usb_ack_suspend();
		}
	#else
		// uNオ菈
		if ((remote_wakeup_feature == ENABLED) && (usb_configuration_nb != 0))
		{
			Usb_disable_suspend_interrupt();
			Usb_ack_wake_up();
			Usb_enable_wake_up_interrupt();
			Usb_suspend_action();
			Usb_freeze_clock();
			// ̌ɉuNオn߂邽߂Ɏgp҂"Usb_initiate_remote_wake_up()"s邱Ƃł܂B
			// ĊJ(Resume)邽߂ɋx~(Suspend)荞(SUSPI)׸ނݒ肳ĂȂ΂ȂȂƂɒӂĂB
			// ̂ɏ璷Ȋ荞݂邽߂SUSPEޯĂ͉Ȃ΂Ȃ܂B
			// ****************
			// ĊJ(νĐؒf)VBUSA(uNオJnɎgpĂꂪʏ푗ꂽʰ޳ɂĉ)
			// RMWKUPޯĂیɐݒɗ܂Âɂ̋@\ǂ@ȉł邱ƂɂӂĂB
//			Usb_unfreeze_clock();
//			Usb_initiate_remote_wake_up();
//			while (Is_usb_pending_remote_wake_up())
//			{
//				if (Is_usb_vbus_low())
//				{
//					// ĊJVBUSȂAً}(ؾ ϸۂȂ)
//					break;
//				}
//			}
//			Usb_ack_remote_wake_up_start();
			// ****************
		}
		else
		{
			// uNオxȂ
			Usb_send_event(EVT_USB_SUSPEND);
			Usb_suspend_action();
			Usb_ack_suspend();
			Usb_ack_wake_up();				// ̎یô߂ɋN
			Usb_enable_wake_up_interrupt();
			Usb_freeze_clock();
		}
	#endif
    }

	// - N(USB̓o):ĊJɎgp܂B
	if (Is_usb_wake_up() && Is_swake_up_interrupt_enabled())
	{
		Usb_unfreeze_clock();
		Usb_ack_wake_up();
		Usb_disable_wake_up_interrupt();
		Usb_ack_suspend();
		Usb_enable_suspend_interrupt();
		Usb_wake_up_action();
		Usb_send_event(EVT_USB_WAKE_UP);
	}
	// - ĊJ޽o
	if (Is_usb_resume() && Is_resume_interrupt_enabled())
	{
		Usb_disable_wake_up_interrupt();
		Usb_ack_resume();
		Usb_disable_resume_interrupt();
		Usb_resume_action();
		Usb_send_event(EVT_USB_RESUME);
	}
	// - USB޽ ؾČo
	if (Is_usb_reset()&& Is_reset_interrupt_enabled())
	{
		Usb_ack_reset();
		usb_init_device();
	#if (USB_OTG_FEATURE == ENABLED)
		if (Is_usb_id_host())
		{
			usb_configure_endpoint(EP_CONTROL,    \
								   TYPE_CONTROL,  \
								   DIRECTION_OUT, \
								   SIZE_8,        \
								   ONE_BANK,      \
								   NYET_DISABLED);
		}
		#if (OTG_COMPLIANCE_TRICKS == ENABLED)
		// ŏ͓̏̂߂ɏdvłB
		// ؾĂŏɎ󂯎Ȃ΂Ȃ܂B
		if (device_state == A_PERIPHERAL)
		{
			otg_last_sof_received = UDFNUML;
			otg_last_sof_stored   = UDFNUML;
			Usb_ack_sof();
			Usb_enable_sof_interrupt();
			reset_received = TRUE;
			Timer16_select(OTG_USE_TIMER);	// ďv
			Timer16_set_counter(0);
		}
		#endif
	#endif
		Usb_reset_action();
		Usb_send_event(EVT_USB_RESET);
	}

// ---------- OTGۊǗ ----------------------------------------------
// ---------------------------------------------------------------------
#if (USB_OTG_FEATURE == ENABLED)
	// - OTG HNPo
	if (Is_usb_role_exchange_interrupt() && Is_role_exchange_interrupt_enabled())
	{
		Usb_ack_role_exchange_interrupt();
		Host_ack_device_connection();
		Host_ack_device_disconnection();
		Otg_send_event(EVT_OTG_HNP_SUCCESS);
		End_session_with_srp();
		Clear_otg_features_from_host();
		if (Is_usb_id_host())
		{
			// (A-܂gB-)νē
			if ((device_state != A_PERIPHERAL) && (device_state != A_END_HNP_WAIT_VFALL))
			{
				// ݂̓A-νāAuA-Ӌ@\̖܂B
				otg_b_device_state = B_PERIPHERAL;
				device_state = A_PERIPHERAL;
				usb_connected = FALSE;
				usb_configuration_nb = 0;
				Usb_select_device();
				Usb_attach();
				Usb_unfreeze_clock();
				Usb_disable_role_exchange_interrupt();
				Usb_disable_hnp_error_interrupt();
				Usb_device_stop_hnp();
				Usb_ack_suspend();
				Usb_ack_reset();
	#if (OTG_COMPLIANCE_TRICKS == ENABLED)
				Timer16_select(OTG_USE_TIMER);	// 4̍ŏ̍s⏞ُTD4.5-2,9ms
				Timer16_set_counter(0);
				Usb_freeze_clock();			// USBۯ͎ۂƏ󋵂̌oቺ邽߂ɓ邱Ƃł܂B
				while (Timer16_get_counter_low() != 20);
				Usb_unfreeze_clock();
				reset_received = FALSE;
				Usb_disable_sof_interrupt();	// OTGv튄荞݂Őݒ肳܂(K{)B
	#endif
				Usb_enable_suspend_interrupt();
				Usb_enable_reset_interrupt();
				usb_configure_endpoint(EP_CONTROL,    \
									   TYPE_CONTROL,  \
									   DIRECTION_OUT, \
									   SIZE_8,        \
									   ONE_BANK,      \
									   NYET_DISABLED);
			}
		}
		else
		{	// B-νēŁAx~(Suspend)`Ԃłꂪ޽J(ASOFJnłȂ)߁AHNPREQޯĂ͉Ă͂Ȃ܂B
			if ((otg_b_device_state != B_HOST) && (otg_b_device_state != B_END_HNP_SUSPEND))
			{
				// ݂̓B-Ӌ@\ŁAuB-νĂ̖ɂȂ܂B
				End_session_with_srp();
				Clear_otg_features_from_host();
				otg_b_device_state = B_HOST;
				device_state = DEVICE_ATTACHED;
				usb_connected = FALSE;
				usb_configuration_nb = 0;
				Usb_select_host();
				Host_enable_sof();			// ν(SOF)Jn
				Host_send_reset();			// ŏؾđo
				Host_disable_reset_interrupt();
				while (Host_is_reset());
				i = 2;
				while (i != 1)
				{
					i++;
				};
				while (i < 5)				// 4ؾĂ𐶐
				{
					while (Host_is_reset());
					Host_send_reset();
					Host_ack_reset();
					i++;
				}

				Usb_disable_role_exchange_interrupt();
				Usb_disable_hnp_error_interrupt();
				Clear_all_user_request();
			}
		}
	}
	// - OTG HNPso
	if (Is_usb_hnp() && Is_usb_hnp_error_interrupt()&& Is_hnp_error_interrupt_enabled())
	{
		Usb_device_stop_hnp();
		Usb_disable_role_exchange_interrupt();
		Usb_disable_hnp_error_interrupt();
		Usb_ack_hnp_error_interrupt();
		if (Is_usb_id_device())
		{
			Otg_send_event(EVT_OTG_HNP_ERROR);
			Clear_all_user_request();
		}
	}
#endif
#endif// End DEVICE FEATURE MODE

// ---------- νĎۊǗ ----------------------------------------------
// ---------------------------------------------------------------------
#if ((USB_HOST_FEATURE == ENABLED && USB_DEVICE_FEATURE == ENABLED) || (USB_OTG_FEATURE == ENABLED))
	// - IDݕωo
	if(Is_usb_id_transition()&&Is_usb_id_interrupt_enabled())
	{
		Usb_device_stop_hnp();
	#if (USB_OTG_FEATURE == ENABLED)
		Clear_all_user_request();
	#endif
		if(Is_usb_id_device())
		{ g_usb_mode=USB_MODE_DEVICE;}
		else
		{ g_usb_mode=USB_MODE_HOST;}
		Usb_ack_id_transition();
		if( g_usb_mode != g_old_usb_mode)	// {IȒ
		{
			if(Is_usb_id_device())			// u`Ԃ֍s
			{
				Usb_send_event(EVT_USB_DEVICE_FUNCTION);
	#if (USB_OTG_FEATURE == ENABLED)
				otg_b_device_state = B_IDLE;
	#endif
				device_state = DEVICE_UNATTACHED;
	#if ((OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED) && (USB_OTG_FEATURE == ENABLED))
				id_changed_to_host_event = DISABLED;
	#endif
			}
			else							// νē`Ԃ֍s
			{
	#if (USB_OTG_FEATURE == ENABLED)
				otg_b_device_state = B_IDLE;
	#endif
				device_state = DEVICE_UNATTACHED;
				Usb_send_event(EVT_USB_HOST_FUNCTION);
	#if ((OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED) && (USB_OTG_FEATURE == ENABLED))
				id_changed_to_host_event = ENABLED;
	#endif
			}
			Usb_id_transition_action();
			LOG_STR_CODE(log_id_change);
	#if (ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
			// IDJڂͳޯ ؾĂ𐶐
		#ifndef  AVRGCC
			Wdt_change_16ms(); while(1);
		#else
			Wdt_change_enable(); while(1);
		#endif
	#endif
		}
	}
#endif
#if ((USB_HOST_FEATURE == ENABLED) || (USB_OTG_FEATURE == ENABLED))
	// - uؒf܂B
	if(Is_device_disconnection() && Is_host_device_disconnection_interrupt_enabled())
	{
		host_disable_all_pipe();
		Host_ack_device_disconnection();
		device_state=DEVICE_DISCONNECTED;
		Usb_send_event(EVT_HOST_DISCONNECTION);
		LOG_STR_CODE(log_device_disconnect);
		Host_device_disconnection_action();
	#if (USB_OTG_FEATURE == ENABLED)
		Clear_all_user_request();
	#endif
	}
	// - uڑ
	if(Is_device_connection() && Is_host_device_connection_interrupt_enabled())
	{
		Host_ack_device_connection();
		host_disable_all_pipe();
		Host_device_connection_action();
	}
	// - ν ڰъJno
	if (Is_host_sof() && Is_host_sof_interrupt_enabled())
	{
		Host_ack_sof();
		Usb_send_event(EVT_HOST_SOF);
		private_sof_counter++;

		// νē`Ԃł̊荞ݓ]ɑ΂xԒߊǗ
	#if ((USB_HOST_PIPE_INTERRUPT_TRANSFER==ENABLE) && (TIMEOUT_DELAY_ENABLE==ENABLE))
		if (private_sof_counter>=250)		// 1/4bv
		{
			private_sof_counter=0;
			for(i=0;i<MAX_EP_NB;i++)
			{
				if(it_pipe_str[i].enable==ENABLE)
				{
					save_pipe_nb=Host_get_selected_pipe();
					Host_select_pipe(i);
					if((++it_pipe_str[i].timeout>TIMEOUT_DELAY) && (Host_get_pipe_type()!=TYPE_INTERRUPT))
					{
						it_pipe_str[i].enable=DISABLE;
						it_pipe_str[i].status=PIPE_DELAY_TIMEOUT;
						Host_stop_pipe_interrupt(i);
						if (is_any_interrupt_pipe_active()==FALSE)	// ȏ]Ȃꍇ
						{
							if (g_sav_int_sof_enable==FALSE)
							{
								Host_disable_sof_interrupt();
							}
						}
						it_pipe_str[i].handle(PIPE_DELAY_TIMEOUT,it_pipe_str[i].nb_byte_processed);
					}
					Host_select_pipe(save_pipe_nb);
				}
			}
		}
	#endif  // (USB_HOST_PIPE_INTERRUPT_TRANSFER==ENABLE) && (TIMEOUT_DELAY_ENABLE==ENABLE))
		Host_sof_action();
	}
	// - νċNオM
	if (Is_host_hwup() && Is_host_hwup_interrupt_enabled())
	{
		Host_disable_hwup_interrupt();		// νĂNĂ̂ŁAN荞݂͋֎~ׂł!B
		Host_disable_remote_wakeup_interrupt();
		// : HWUPUSBۯ(񓀌)̎ɂ(0)邱Ƃł܂B
		Pll_start_auto();					// USBpPLL̍ŏ̍Ďn
		Wait_pll_ready();					// PLLŒ艻mɂ邽߂̑҂
		Usb_unfreeze_clock();				// USB̪Ÿۯ
		Host_enable_sof();					// SOFoJn
		Host_ack_hwup();					// HWUP荞ݗv׸މ(0)
		Host_ack_remote_wakeup();
		Usb_send_event(EVT_HOST_HWUP);		// ĳۑo
		Usb_send_event(EVT_HOST_REMOTE_WAKEUP);
		Host_hwup_action();					// Ǝ蓖
	#if (USB_OTG_FEATURE == ENABLED)
		if (Is_usb_hnp())
		{
//			Usb_host_reject_hnp();
			Usb_disable_hnp_error_interrupt();
			Usb_disable_role_exchange_interrupt();
		}
	#endif
		Host_send_resume();
	}

	// uNオM
	if (Is_host_remote_wakeup_interrupt_enabled() && Is_host_remote_wakeup())
	{
		Host_disable_remote_wakeup_interrupt();
		Host_disable_hwup_interrupt();
		Host_ack_remote_wakeup();
		Host_ack_hwup();					// HWUP荞ݗv׸މ(0)
		Pll_start_auto();					// USBpPLL̍ŏ̍Ďn
		Wait_pll_ready();					// PLLŒ艻mɂ邽߂̑҂
		Usb_unfreeze_clock();				// USB̪Ÿۯ
		Host_enable_sof();					// SOFoJn
		Usb_send_event(EVT_HOST_REMOTE_WAKEUP);
		Usb_send_event(EVT_HOST_HWUP);		// ĳۑo
	#if (USB_OTG_FEATURE == ENABLED)
		if (Is_usb_hnp())
		{
//			Usb_host_reject_hnp();
			Usb_disable_hnp_error_interrupt();
			Usb_disable_role_exchange_interrupt();
		}
	#endif
		Host_send_resume();
	}
#endif // End HOST FEATURE MODE
}

#if (USB_OTG_FEATURE == ENABLED)

// ---------- OTGݸފǗ --------------------------------------------
// ---------------------------------------------------------------------
//! @brief OTGv튄荞ݻٰ
//!
//! ̊֐OTGv튄荞݂N(8MHz2ms)ɌĂ΂܂B
//! ֐OTG۸тɂĕKvƂϐ炵܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef AVRGCC
  #if (OTG_USE_TIMER == TIMER16_1)
	ISR(TIMER1_COMPA_vect)
  #else
	ISR(TIMER3_COMPA_vect)
  #endif
#else
  #if (OTG_USE_TIMER == TIMER16_1)
	#pragma vector = TIMER1_COMPA_vect
  #else
	#pragma vector = TIMER3_COMPA_vect
  #endif
__interrupt void otg_timer_interrupt()
#endif
{
#if (USE_TIMER16 == BOTH_TIMER16)
	U8 tmr_sel_save = timer16_selected;		// ݑIĂvۑ
#endif

	Timer16_select(OTG_USE_TIMER);
	Timer16_clear_compare_a_it();

	//! OTG Messaging timer
#if ((OTG_MESSAGING_OUTPUT == OTGMSG_ALL) || (OTG_MESSAGING_OUTPUT == OTGMSG_FAIL))
	if ((Get_failure_msg_delay() != 0x0000) && (Get_failure_msg_delay() != 0xFFFF))   { Decrement_failure_msg_delay(); }
  #if (OTG_MESSAGING_OUTPUT == OTGMSG_ALL)
	if ((Get_event_msg_delay() != 0x0000) && (Get_event_msg_delay() != 0xFFFF))       { Decrement_event_msg_delay(); }
  #endif
#endif

	//! KvȂTb_Srpv𑝉
	if (Is_srp_sent_and_waiting_answer()) { otg_tb_srp_cpt++; }

	//! KvȂT_vbus_wait_connect𑝉
	if (Is_srp_received_and_waiting_connect()) { otg_ta_srp_wait_connect++; }

	//! Kv(A_SUSPEND)ȂTa_aidl_bdisv
	if ((device_state == A_SUSPEND) && (otg_ta_aidl_bdis_tmr > 1))
		{ otg_ta_aidl_bdis_tmr--; }

	//! KvȂTimeout_bdev_respondv
	if ((device_state == DEVICE_DEFAULT) && (!Is_timeout_bdev_response_overflow()))
		{ otg_timeout_bdev_respond--; }

	//! KvȂTa_vbus_risev
	if (!Is_ta_vbus_rise_counter_overflow()) { otg_ta_vbus_rise--; }

	//! KvȂTa_vbus_fallv
	if (!Is_ta_vbus_fall_counter_overflow()) { otg_end_hnp_vbus_delay--; }

	//! K̂߂ɕKv
#if (OTG_COMPLIANCE_TRICKS == ENABLED)
	if (device_state == A_PERIPHERAL)
	{
		if (Is_sof_interrupt_enabled() && (reset_received == TRUE))
		{
			if (otg_last_sof_stored != otg_last_sof_received)
			{
				// SOF𓦂ȂB
				otg_last_sof_received = otg_last_sof_stored;
			}
			else
			{
				// SOF͎蓦ƎvB
				Usb_freeze_clock();
				Usb_disable_sof_interrupt();
				reset_received = FALSE;
				while (Timer16_get_counter_low() != 20);	// usb_task.h62ɐݒ
				Usb_unfreeze_clock();
			}
			otg_last_sof_received = UDFNUML;
			otg_last_sof_stored = UDFNUML;
		}
	}
#endif

#if (USE_TIMER16 == BOTH_TIMER16)
	Timer16_select(tmr_sel_save);			// 荞݈ڍsOɑIĂv𕜌
#endif
}

// ---------- OTGүފǗ --------------------------------------------
// ---------------------------------------------------------------------
//! @brief OTGүލƏ
//!
//! ׂүނ邽߂ɕϐƉʂ
//! ̊֐̏łSPIDERœALCD3̉ʑsKvłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void Otg_message_task_init (void)
{
	Otg_messaging_init();
	otg_msg_event_delay = 0;
	otg_msg_failure_delay = 0;
}

//! @brief OTGүގ
//!
//! OTG͎gp҂lXȎۂ̒ʒmێȂȂȂƂw܂B
//! ̍Ƃ͎ۂƎs2ނүނ̕\gp҂ɋ܂B
//! eVKүނɑ΂āAw肵x̊ԂA܂͑SĂ̎Ԃүނ\ɗ܂邩w肷邱Ƃł܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void Otg_message_task (void)
{
	// OTGүނȂ΂ȂȂ(w肳ꂽxԍ\ݒ肳Ă)𒲍
#if ((OTG_MESSAGING_OUTPUT == OTGMSG_ALL) || (OTG_MESSAGING_OUTPUT == OTGMSG_FAIL))
	if (Get_failure_msg_delay() == 0) { Otg_clear_failure_message(); }
  #if (OTG_MESSAGING_OUTPUT == OTGMSG_ALL)
	if (Get_event_msg_delay() == 0)   { Otg_clear_event_message();   }
  #endif
#endif
}
#endif

extern void suspend_action (void)
{
	Enable_interrupt();
	Enter_power_down_mode();
}

extern void host_suspend_action (void)
{
//	Enter_power_down_mode();				// ...
}

void otg_not_supported_device (void)
{
  Otg_send_event(EVT_OTG_DEV_UNSUPPORTED);
}
